"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buildOptions = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

const defaultSettings = {
  injectScope: false,
  injectVariableName: true,
  injectFileName: true
};
const defaultMethods = ['debug', 'error', 'exception', 'info', 'log', 'warn']; // this should deep merge in the future when we are dealing with more than just flags

const mergeOptions = options => {
  const sanitizedOptions = Object.keys(options || {}).filter(key => Object.keys(defaultSettings).includes(key)).reduce((acc, key) => (0, _objectSpread2.default)({}, acc, {
    [key]: options[key]
  }), {});
  return Object.assign({}, defaultSettings, sanitizedOptions);
};

let cachedUserOptions = null;
let cachedBuildOptions = null;

const buildOptions = userOptions => {
  if (cachedUserOptions !== userOptions) {
    cachedUserOptions = userOptions; // remove ignore patterns from settings since it has been consumed already
    // eslint-disable-next-line no-unused-vars

    const _ref = userOptions || {},
          {
      methods,
      ignorePatterns
    } = _ref,
          options = (0, _objectWithoutProperties2.default)(_ref, ["methods", "ignorePatterns"]); // output spreads the flags over each method
    // in the future this could be expanded to allow method level config


    cachedBuildOptions = (methods || defaultMethods).reduce((acc, method) => {
      return (0, _objectSpread2.default)({}, acc, {
        [method]: mergeOptions(options)
      });
    }, {});
  }

  return cachedBuildOptions;
};

exports.buildOptions = buildOptions;
//# sourceMappingURL=pluginOptions.js.map